#ifndef CORE_PLANE_HPP
#define CORE_PLANE_HPP

#include "core/math/Vector.hpp"
#include "core/utils/ArrayString.hpp"

namespace Core {
    class Plane final {
        Vector3 abc;
        float d;

    public:
        Plane();
        Plane(const Vector3& a, const Vector3& b, const Vector3& c);
        float getSignedDistance(const Vector3& v) const;

        void toString(BufferString& s) const {
            s.append("(");
            s.append(abc[0]);
            s.append(" x + ");
            s.append(abc[1]);
            s.append(" y + ");
            s.append(abc[2]);
            s.append(" z + ");
            s.append(d);
            s.append(')');
        }
    };
}

#endif
